jxWebUI只有一个html文件：tms.html。所有的web组件都是开发人员编程或用文本进行定义，然后在用户登录时生成一个对应的页面json描述，发送到浏览器中，由浏览器解释并动态创建相应的web组件，然后加载到tms.html中。

tms.html左侧是快捷栏区域，用于放置一个二级的快捷目录树。是用户使用各种功能的入口。

tms.html中部是主显示区。该显示区主要包括一个tabs容器，最多可以包含5个tab。开发人员定义的主页面都显示到tab中。当用户打开第6个主页面时，最久未使用的tab就会被自动关闭，其中加载的capa被自动卸载。

每个tab包括两个部分：

- 主界面，是tab的主体
- 工具栏，位于tab的最上方，用于容纳主界面所管理的工具条

主界面用于显示主page，如果该page关联了工具条，则符合当前用户权限的工具条就会显示到工具栏中。

![test_web](http://115.29.52.95:10018/images/web_1.png)

一个tab可以包括一个主page和多个对话框的page，这些page都共享同一个capaInstance。每个capaInstance都是开发者所定义的capa的实例化。这些概念的对应关系为：

- capa是python代码和web界面的桥梁，同时定义了web界面以及相应的事件函数【页面初始化事件函数和按钮点击事件函数】，一个capa为一个模块，如设备管理、人员管理等，定义本模块中需要用到的所有web界面
- capaInstance是capa的实例化，对应浏览器中的一个tab，收集用户在这个tab中所有输入控件的输入，关联该tab中各按钮、工具条相应的事件响应函数。一个capaInstance管理的web界面只是capa的一个子集，只包含一个主page和多个对话框page

简单的说，capa负责的是web界面和事件函数的定义，capaInstance负责web界面实际显示时的输入输出。
##### web界面定义步骤

1、创建capa

web界面依赖于capa，所以必须先创建一个capa。不同模块的capa名字要唯一，当要查看其它模块的页面时，就必须明确给出capaname参数，如审批一个销售订单时，可能想查看客户付款/信用信息、销售的历史业绩等等，此时就需要明确指出希望打开页面的capaname。

2、定义page

用capa.web或capa.page修饰符来定义page

3、根据page的使用工作流发布page的显示入口

- 创建、查看这样的工作流起点或独立任务，将page的显示菜单添加到快捷栏中
- 工作流中的其它page，如果不需求额外的权限控制，就由工作流中前一page中的按钮来打开本page
- 如果需要额外的权限控制，如某些人可以编辑、某些人只能查看，这样的page就由主page的工具栏中的工具条进行启动

4、给page编写事件响应函数

jxWebUI中的事件有：

- disp事件，某page在被显示到浏览器中时触发，执行该page的初始化数据装订工作
- cmd事件，用户在浏览器中点击了按钮、工具条时，其定义时的属性motion如果是cmd，则点击该按钮就会触发demand属性指定的事件。按钮、工具条的motion属性如果是disp，则点击按钮就会显示demand属性指定的page
- 数据变动事件，当用户在输入控件输入后，会触发该控件bind属性同名的数据变动事件

disp事件响应函数就是定义该page时用capa.disp修饰的函数；cmd事件和数据变动事件响应函数是用capacmd修饰符修饰的函数。

事件响应函数有三个参数：

	capaInstance:调用该函数的capa实例，主要提供和web界面的IO
	db:数据库连接，jxWebUI已经为本次调用准备好了数据库事务以保证本函数执行时数据库的原子性
	ctx:上下文，目前只提供了登录用户的信息
