
jxWebUI必须登录才可以使用，但为便于开发者根据自己的需要进行定制，所以jxWebUI本身并未内置任何用户认证功能。，而是提供了一个回调接口，由开发者自行实现用户认证功能。

该接口为：

	from jxWebUI import jxWebGetUser
    jxWebGetUser(get_user)

其中get_user是开发者提供的一个函数，其签名为：
	get_user(user, pwd) -> User:

User是一个鸭子类型，可以由开发者自定义的一个类，其必须包含name、abbr、roles三个函数。形如：

	class User:  
	    def __init__(self, name):  
	        self._name = name  
	        self._abbr = name  
	        self._roles = [ ]  
	  
	    def name(self):  
            #用户的实际姓名【可能重名】
	        return self._name  
	    def abbr(self):  
            #用户在组织中的唯一名
	        return self._abbr  
	    def roles(self):  
            #用户分配到的所有角色
	        return self._roles  
	#具体应用 
	def get_user(user, pwd):  
	    return User(user)  
	jxWebGetUser(get_user)

jxWebUI默认不需get_user，而这意味着任何用户都可以登录。如果需要验证，则需要送入开发者自定义的get_user函数，对登录名和密码进行校验即可。返回None则代表登录失败，用户将无法登入。

返回的是开发者自定义的一个对象，必须要有name、abbr、roles三个函数，否则会执行失败，无法返回左侧的快捷栏，则用户见到的就会是一个空白页面。
